<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="html" encoding="iso-8859-15" indent="yes"/>
  
  <xsl:template match="/">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="statistics">
    <html>
      <head>
        <title><xsl:value-of select="results/title"/></title>
        <link rel="stylesheet" type="text/css" media="screen, print" href="../../tournament.css"/>
      </head>

      <body>
        <div id="title">
          <h1><xsl:value-of select="@title"/></h1>
        </div>
        
        <div id="main">
          <xsl:apply-templates/>
        </div>
        
        <div id="footer">
          <a href="http://kickofftug.tugraz.at">KickOffTUG</a> | <a href="http://www.tugraz.at">Graz University of Technology</a>, 2009
        </div>
      </body>
    </html>
  </xsl:template>
  
  <xsl:template match="statistic">
    <h2><xsl:value-of select="@class"/></h2>
    <xsl:apply-templates/>
  </xsl:template>
  
  <xsl:template match="section">
    <h3><xsl:value-of select="@name"/></h3>
    <table>
      <xsl:apply-templates/>
    </table>
  </xsl:template>
  
  <xsl:template match="headers">
    <tr>
      <th>-</th>
      <xsl:apply-templates/>
    </tr>
  </xsl:template>
  
  <xsl:template match="header">
    <th><xsl:value-of select="@title"/></th>
  </xsl:template>
  
  <xsl:template match="entry">
    <tr>
      <th class="entry"><xsl:value-of select="@name"/>:</th>
      <xsl:for-each select="data">
        <td class="data"><xsl:value-of select="."/></td>
      </xsl:for-each>
    </tr>
  </xsl:template>

  <xsl:template match="data">
  </xsl:template>

</xsl:stylesheet>
